<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, Pre-Release 7.6 (jan08.1) of Freitag, 11. Januar 2008 on Samstag, 9. Februar 2008 at 12:40:13</time-stamp>
<!-- Package SeasideEnhancements(1.0,holgi)= -->


<component-property>
<name>SeasideEnhancements</name> <type>package</type>
<property>prerequisiteParcels</property> <value>#(#('Seaside' '') #('Seaside-Mootools' '') #('System-Announcements' ''))</value>
</component-property>

<component-property>
<name>SeasideEnhancements</name> <type>package</type>
<property>kSignature</property> <value>#('definedClasses' 6 'definedClassesHash' 3865150297 'extendedClasses' 5 'extendedClassesHash' 1201119849)</value>
</component-property>

<component-property>
<name>SeasideEnhancements</name> <type>package</type>
<property>developmentPrerequisites</property> <value>#(#(#any 'Seaside' '') #(#any 'Seaside-Mootools' '') #(#any 'System-Announcements' ''))</value>
</component-property>

<component-property>
<name>SeasideEnhancements</name> <type>package</type>
<property>comment</property> <value>'1. AJAX enhancements:

- in the component that encloses the asynchronously updated area, the render method looks like this:

renderContentOn: canvas
   ...
   canvas div
     id: canvas nextId;
     asyncRenderWith: [ : updateCanvas |
       self renderDynamicContentOn: updateCanvas
     ]. 

- in the component with the callback, the render method looks like this

renderContentOn: canvas
   ...
   canvas anchor
     asyncCallback: [ ... ];
     with: [ ...  ] 

2. Announcement enhancements

add a back link from each child component to its parent (but keep it private, no component should explicitely send stuff to its parent).

- implement #announceOrDelegate:. This method checks if there are any subscribers for the specific announcement. If yes it is announced, otherwise the component delegates the announcement to the parent component (the only piece of code that uses the back link to the parent component). '</value>
</component-property>

<class>
<name>AsyncUpdater</name>
<environment>Seaside</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>id renderBlock </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>SeasideEnhancements</package>
</attributes>
</class>

<class>
<name>MootoolsAsyncUpdater</name>
<environment>Seaside</environment>
<super>Seaside.AsyncUpdater</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>SeasideEnhancements</package>
</attributes>
</class>

<class>
<name>ExampleTreeComponent</name>
<environment>Seaside</environment>
<super>Seaside.WAComponent</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>exampleClass children parentComponent isExpanded subscriptionRegistry </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>SeasideEnhancements</package>
</attributes>
</class>

<class>
<name>AsyncUpdatedArea</name>
<environment>Seaside</environment>
<super>Seaside.WACompound</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>updater </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>SeasideEnhancements</package>
</attributes>
</class>

<class>
<name>ExampleClassVisitAnnouncement</name>
<environment>Seaside</environment>
<super>Core.Announcement</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>exampleClass </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>SeasideEnhancements</package>
</attributes>
</class>

<class>
<name>ExampleRootComponent</name>
<environment>Seaside</environment>
<super>Seaside.WAComponent</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>treeComponent rootClass </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>SeasideEnhancements</package>
</attributes>
</class>












<methods>
<class-id>Seaside.ExampleClassVisitAnnouncement class</class-id> <category>instance creation</category>

<body package="SeasideEnhancements">exampleClass: aExampleClass 

	^ (self new)
		exampleClass: aExampleClass;
		yourself</body>
</methods>


<methods>
<class-id>Seaside.ExampleClassVisitAnnouncement</class-id> <category>accessing</category>

<body package="SeasideEnhancements">exampleClass: aExampleClass 

	exampleClass := aExampleClass</body>

<body package="SeasideEnhancements">exampleClass

	^ exampleClass</body>
</methods>


<methods>
<class-id>Seaside.ExampleRootComponent class</class-id> <category>class initialization</category>

<body package="SeasideEnhancements">initialize
	"self unregisterApplicationFrom: WADispatcher default."

	| app |
	app := self registerAsApplication: 'SeasideEnhancements'.
	app addLibrary: Mootools.MootoolsLibrary.</body>
</methods>

<methods>
<class-id>Seaside.ExampleRootComponent class</class-id> <category>testing</category>

<body package="SeasideEnhancements">canBeRoot
	
	^ true</body>
</methods>

<methods>
<class-id>Seaside.ExampleRootComponent class</class-id> <category>accessing</category>

<body package="SeasideEnhancements">description

	^ 'Seaside enhancements (announcements and AJAX) example '</body>
</methods>


<methods>
<class-id>Seaside.ExampleRootComponent</class-id> <category>accessing</category>

<body package="SeasideEnhancements">treeComponent

	treeComponent isNil 
		ifTrue: [  
			treeComponent := ExampleTreeComponent onClass: self rootClass.
			treeComponent when: ExampleClassVisitAnnouncement do: [ : visit | self visit: visit exampleClass ].
		].
	^ treeComponent</body>

<body package="SeasideEnhancements">rootClass: aRootClass 

	rootClass := aRootClass</body>

<body package="SeasideEnhancements">children

	^ Array with: self treeComponent</body>

<body package="SeasideEnhancements">rootClass

	^ rootClass ifNil: [rootClass := WATagBrush ]</body>

<body package="SeasideEnhancements">visit: aClass

	self call: (self class new rootClass: aClass; yourself).</body>
</methods>

<methods>
<class-id>Seaside.ExampleRootComponent</class-id> <category>rendering</category>

<body package="SeasideEnhancements">renderContentOn: canvas

	canvas unorderedList: [
		canvas render: self treeComponent.
	].</body>
</methods>


<methods>
<class-id>Seaside.AsyncUpdatedArea class</class-id> <category>instance creation</category>

<body package="SeasideEnhancements">updater: aUpdater 

	^ (self new)
		updater: aUpdater;
		yourself</body>
</methods>


<methods>
<class-id>Seaside.AsyncUpdatedArea</class-id> <category>public</category>

<body package="SeasideEnhancements">with: anObject

	updater isNil
		ifTrue: [ updater := AsyncUpdater 
					id: parent id
					renderWith: 
					[ : update : updateCanvas |
						updateCanvas render: anObject.
					 ]].
	super with: anObject.</body>
</methods>

<methods>
<class-id>Seaside.AsyncUpdatedArea</class-id> <category>accessing</category>

<body package="SeasideEnhancements">updater: aUpdater 

	updater := aUpdater</body>

<body package="SeasideEnhancements">updater

	^ updater</body>

<body package="SeasideEnhancements">asyncUpdater

	^ updater</body>
</methods>


<methods>
<class-id>Seaside.AsyncUpdater class</class-id> <category>instance creation</category>

<body package="SeasideEnhancements">id: aId renderWith: aUpdateBlock 

	^ (self new)
		id: aId;
		renderBlock: aUpdateBlock;
		yourself</body>
</methods>


<methods>
<class-id>Seaside.AsyncUpdater</class-id> <category>accessing</category>

<body package="SeasideEnhancements">id

	^ id</body>

<body package="SeasideEnhancements">onEventHandlerFor: canvas callback: callbackBlock 

	self subclassResponsibility</body>

<body package="SeasideEnhancements">renderBlock

	^ renderBlock</body>

<body package="SeasideEnhancements">renderBlock: aUpdateBlock 

	renderBlock := aUpdateBlock</body>

<body package="SeasideEnhancements">id: aId 

	id := aId</body>
</methods>

<methods>
<class-id>Seaside.AsyncUpdater</class-id> <category>rendering</category>

<body package="SeasideEnhancements">renderOn: canvas

	self renderBlock cull: self cull: canvas</body>
</methods>


<methods>
<class-id>Seaside.MootoolsAsyncUpdater</class-id> <category>accessing</category>

<body package="SeasideEnhancements">onEventHandlerFor: canvas callback: callbackBlock 

	^ ((canvas mooRequestHtml)
		update: self id;
		callback: 
			[ : updateCanvas | | syncBrush |
				syncBrush := updateCanvas brush: (AsyncUpdatedArea updater: self).
				syncBrush updater: self.
				syncBrush with: 
					[ 	callbackBlock cull: updateCanvas.
						self renderBlock cull: self cull: updateCanvas 
					 ] 
			 ]) 
			send</body>
</methods>


<methods>
<class-id>Seaside.ExampleTreeComponent class</class-id> <category>instance creation</category>

<body package="SeasideEnhancements">onClass: aExampleClass 

	^ super new
		exampleClass: aExampleClass ;
		buildComponents;
		yourself</body>
</methods>


<methods>
<class-id>Seaside.ExampleTreeComponent</class-id> <category>private</category>

<body package="SeasideEnhancements">buildComponents

	| sortedClasses |
	sortedClasses := self exampleClass subclasses 
				asSortedCollection: [ : cl1 : cl2 | cl1 displayString &lt;= cl2 displayString  ].
	children := sortedClasses collect: 
				[ : cl | | childComponent |
					childComponent := self class onClass: cl.
					childComponent parentComponent: self.
					childComponent 
				 ]</body>

<body package="SeasideEnhancements">parentComponent

	^ parentComponent</body>

<body package="SeasideEnhancements">parentComponent: aParentComponent 

	parentComponent := aParentComponent</body>
</methods>

<methods>
<class-id>Seaside.ExampleTreeComponent</class-id> <category>accessing</category>

<body package="SeasideEnhancements">exampleClass: aExampleClass 

	exampleClass := aExampleClass</body>

<body package="SeasideEnhancements">isExpanded

	^ isExpanded ifNil: [ isExpanded := false ].</body>

<body package="SeasideEnhancements">isExpanded: aBoolean

	isExpanded := aBoolean</body>

<body package="SeasideEnhancements">states

	^ Array with: self isExpanded</body>

<body package="SeasideEnhancements">exampleClass

	^ exampleClass</body>

<body package="SeasideEnhancements">children

	^ children</body>
</methods>

<methods>
<class-id>Seaside.ExampleTreeComponent</class-id> <category>rendering</category>

<body package="SeasideEnhancements">renderToggleOn: canvas 

	| text |
	self children notEmpty 
		ifTrue: 
		[ 	text := self isExpanded 
						ifTrue: [  '-'  ]
						ifFalse: [  '+'  ].
			(canvas anchor)
				asyncCallback: [  self isExpanded: self isExpanded not  ];
				with: [  canvas text: text ] 
		 ]</body>

<body package="SeasideEnhancements">renderClassOn: canvas 

	canvas text: self exampleClass displayString.
	canvas text: ' ('.
	(canvas anchor)
		callback: [  self announceVisit  ];
		with: [  canvas text: 'Focus'  ].
	canvas text: ')'.</body>

<body package="SeasideEnhancements">renderContentOn: canvas 

	(canvas listItem)
		id: canvas nextId;
		asyncRenderWith: 
			[ 	: updateCanvas |
				self renderToggleOn: updateCanvas.
				updateCanvas space.
				self renderClassOn: updateCanvas .
				(self isExpanded and: [  self children notEmpty  ]) 
					ifTrue: [  updateCanvas unorderedList: [  self children do: [ : comp | updateCanvas render: comp  ]  ]  ] 
			 ]</body>
</methods>

<methods>
<class-id>Seaside.ExampleTreeComponent</class-id> <category>announcements</category>

<body package="SeasideEnhancements">announceVisit

	self announceOrDelegate: (ExampleClassVisitAnnouncement exampleClass: self exampleClass)</body>

<body package="SeasideEnhancements">subscriptionRegistryOrNil

	^subscriptionRegistry</body>

<body package="SeasideEnhancements">subscriptionRegistry: aSubscriptionRegistry

	subscriptionRegistry := aSubscriptionRegistry</body>
</methods>


<methods>
<class-id>Seaside.WAComponent</class-id> <category>announcements</category>

<body package="SeasideEnhancements">delegate: anAnnouncementOrClass 

	^ self parentComponent ifNotNil: [ : pc | pc announceOrDelegate: anAnnouncementOrClass  ]</body>

<body package="SeasideEnhancements">announceOrDelegate: anAnnouncementOrClass 

	| announcement  |
	announcement := anAnnouncementOrClass asAnnouncement.
	(self mayAnnounce: announcement class) 
		ifFalse: [  self errorBadAnnouncementClass: announcement class  ].
	self subscriptionRegistryOrNil ifNotNil: 
		[ : registry |
			(registry tryDeliver: announcement from: self) 
				ifTrue: [ ^ announcement ] 
		 ].
	self delegate: announcement.
	^ announcement</body>

<body package="SeasideEnhancements">parentComponent
	" Never send stuff directly to the parent! Only used for passing announcements "

	^ nil</body>
</methods>


<methods>
<class-id>Seaside.WABrush</class-id> <category>accessing</category>

<body package="SeasideEnhancements">asyncUpdater

	^ parent notNil 
		ifTrue: [  parent asyncUpdater  ]
		ifFalse: [  nil  ]</body>
</methods>


<methods>
<class-id>Seaside.WARenderCanvas</class-id> <category>accessing</category>

<body package="SeasideEnhancements">asyncRenderWith: aBlock updatedBrush: updatedBrush 

	| updater syncBrush |
	updater := self asyncUpdaterClass 
				id: updatedBrush id
				renderWith: [ : update : updateCanvas | aBlock cull: updateCanvas  ].
	syncBrush := self brush: (AsyncUpdatedArea updater: updater).
	^ syncBrush with: aBlock</body>

<body package="SeasideEnhancements">asyncRenderWith: aBlock

	^ self asyncRenderWith: aBlock updatedBrush: parentBrush</body>

<body package="SeasideEnhancements">useAsyncCallbacks

	^ true</body>

<body package="SeasideEnhancements">asyncUpdaterClass

	^ MootoolsAsyncUpdater</body>
</methods>


<methods>
<class-id>Core.SubscriptionRegistry</class-id> <category>privileged</category>

<body package="SeasideEnhancements">tryDeliver: announcement from: anObject 

	| subscribed |
	subscribed := false.
	classesAndSubscriptions keysAndValuesDo: 
		[:class :subscriptions |
		(announcement isKindOf: class) ifTrue:
			[subscriptions do: 
				[:eachSubscription |
				subscribed := true.
				eachSubscription process: announcement from: anObject]]].
	^ subscribed</body>
</methods>


<methods>
<class-id>Seaside.WATagBrush</class-id> <category>accessing</category>

<body package="SeasideEnhancements">asyncRenderWith: aBlock 

	self id isNil ifTrue: [ self error: 'Brush has no ID, async callbacks not possible' ].
	^ self with: [  canvas asyncRenderWith: aBlock updatedBrush: self  ]</body>

<body package="SeasideEnhancements">asyncCallback: callbackBlock

	| updater |
	(canvas useAsyncCallbacks and: [ (updater := self asyncUpdater) notNil ])
		ifTrue: [
			self onClick: (updater onEventHandlerFor: canvas callback: callbackBlock)
		]
		ifFalse: [
			self callback: callbackBlock
		].</body>
</methods>



<initialize>
<class-id>Seaside.ExampleRootComponent</class-id>
</initialize>

</st-source>
